package rwth.i2.ltlrv.afastate.impl;

import java.util.Set;

import rwth.i2.ltlrv.afastate.base.NullaryAFAState;
import rwth.i2.ltlrv.afastate.interfaze.IAFAState;
import rwth.i2.ltlrv.afastate.interfaze.ITT;
import rwth.i2.ltlrv.data.PropositionSet;
import rwth.i2.ltlrv.data.WeakValuesMap;
import rwth.i2.ltlrv.util.SetUtils;

/**
 * TT - Implements the sink state / formula representing <code>true</code>. 
 * 
 * @author Eric Bodden
 */
public class TT extends NullaryAFAState implements ITT {

    /**
     * {@inheritDoc}
     */
    public boolean isFinalStateInAFA() {
		//TT is always final in an AFA
        return true;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public boolean equals(Object obj) {
        return obj instanceof ITT;
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    @SuppressWarnings("unused")
    public void doTransition(Set<String> context, PropositionSet currentProps, WeakValuesMap<String, Object> currentBinding, Set<Set<IAFAState>> result) {
        //add the empty set representing TT
        result.add(SetUtils.clauseTT());
    }

    /**
     * {@inheritDoc}
     */
    public String symbol() {
        return "TT";
    }

}
