package rwth.i2.ltlrv.afastate.interfaze;

import rwth.i2.ltlrv.formula.interfaze.IBinaryTerm;
import rwth.i2.ltlrv.formula.interfaze.IFormula;

/**
 * IBinaryAFAState - Common interface for all binary AFA states.
 * 
 * @author Eric Bodden
 */
public interface IBinaryAFAState extends IBinaryTerm, IAFAState {
    
    /**
     * Creates a formula with the same operator as <code>this<code>
     * but different subformulae. This is used for recursion with
     * nondestructive updates.
     * @param subformula1 left subformula
     * @param subformula2 right subformula
     * @return the new instance
     */
    public IAFAState reconstruct(IFormula subformula1, IFormula subformula2);

}
