package rwth.i2.ltlrv.formula.base;

import rwth.i2.ltlrv.formula.interfaze.IBinaryTerm;
import rwth.i2.ltlrv.formula.interfaze.IFormula;

/**
 * BinaryFormula - Abstract superclass of all binary formulae.
 * 
 * @author Eric Bodden
 */
public abstract class BinaryFormula extends AbstractFormula implements IBinaryTerm {

    /** the subformulae */
    protected IFormula subformula1, subformula2; 
    
    /**
     * @param subformula1 left subformula
     * @param subformula2 right subformula
     */
    public BinaryFormula(IFormula subformula1, IFormula subformula2) {
        this.subformula1 = subformula1;
        this.subformula2 = subformula2;
    }
    
    /**
     * {@inheritDoc}
     */
    public IFormula getSubformula1() {
        return subformula1;
    }
    
    /**
     * {@inheritDoc}
     */
    public IFormula getSubformula2() {
        return subformula2;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    //simply resurse
    public String toString() {
        return "(" +
            this.subformula1.toString() +
            ") " + 
            this.symbol() +
            " (" +             
            this.subformula2.toString() +
            ")";
    }
    
}
