package rwth.i2.ltlrv.formula.impl;

import rwth.i2.ltlrv.afastate.interfaze.IAFAState;
import rwth.i2.ltlrv.formula.base.BinaryFormula;
import rwth.i2.ltlrv.formula.interfaze.IImplies;
import rwth.i2.ltlrv.formula.interfaze.IFormula;

/**
 * Implies - Implements the <i>Implies</i> relation as subformula.
 * 
 * @author Eric Bodden
 */
public class Implies extends BinaryFormula implements IImplies {

    /**
     * @param subFormula1 left subformula
     * @param subFormula2 right subformula
     */
    public Implies(IFormula subFormula1, IFormula subFormula2) {
        super(subFormula1,subFormula2);
    }

    /**
     * {@inheritDoc}
     */
    public String symbol() {
        return "->";
    }

    /**
     * {@inheritDoc}
     */
    public IAFAState negationNormalForm() {
        //s1 -> s2 = !s1 || s2
        return factory.Or(
                factory.Not(subformula1),
        		subformula2
        ).negationNormalForm();
    }

}
